/*
			Copyright (c) 1994 by
			Advanced Visual Systems Inc.
			All Rights Reserved
	
	This software comprises unpublished confidential information of
	Advanced Visual Systems Inc. and may not be used, copied or made
	available to anyone, except in accordance with the license
	under which it is furnished.
	
	This file is under Perforce control
	$Id: //depot/express/fcs992/tool/image.c#1 $
*/
#include <stdio.h>
#include <avs/util.h>

#include <avs/dll_in.h>
#include <avs/err.h>

#include <avs/f_utils.h>

#define ERR_RETURN(A) {ERRerror("write image",1,ERR_ORIG, A); return(0);}

int UTILwrite_image(dims, img_data, filename, flip)
int *dims;
char *img_data;
char *filename;
int flip;
{
   FILE *fp;
   char *idata_ptr;
   int i;

   fp = (FILE *)FILEfopen(filename, SIO_W_BIN);
   if (fp == NULL) {
      ERR_RETURN("Could not open output file");
   }

   /* Write the dimensions of image. This should be 8 bytes, 4 each
      for the x and y size.
   */
   if (fwrite((char *)dims, 8, 1, fp) != 1) {
      fclose(fp);
      ERR_RETURN("Could not write image header");
   }

   /* See if the user has requested that we flip the data. */
   if (!flip) {
      /* Write the image data. The size is x * y * 4 (veclen = 4). */
      if (fwrite((char *)img_data, dims[0]*dims[1]*4, 1, fp) != 1) {
         fclose(fp);
         ERR_RETURN("Could not write image data");
      }
   }
   else {
      /* We need to flip the buffer as the user requested. So
         scan the buffer from the bottom to the top a line at a
         time. 
      */
      idata_ptr = img_data;
      idata_ptr += dims[0] * (dims[1] - 1) * 4;
      for (i=0; i<dims[1]; i++) {
         if (fwrite((char *)idata_ptr, dims[0]*4, 1, fp) != 1) {
            fclose(fp);
            ERR_RETURN("Could not write line of image data");
         }
         idata_ptr -= dims[0] * 4;
      }
   }
   fclose(fp);
   return(1);
}
